> ## Documentation Index
> Fetch the complete documentation index at: https://docs.trlyr.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Get the projected state of energy of a virtual asset.

> DEPRECATED: This endpoint is deprecated and will be removed in a future version. To retrieve state of energy values, use the operational endpoint `GET /organisations/{organisationID}/virtual-assets/{virtualAssetID}/operational`.

Get the projected state of energy of a virtual asset, along with operational limits on that state of energy.

Returns a timeseries of the projected state of energy of a virtual asset as JSON. The points of the timeseries represent the state of energy of the virtual asset at the instant of the timestamp.

The boundaries represent operational limits within which the state of energy should be kept. If the projected `soe` moves outside these bounds then you should aim to change the schedule such that it returns to these limits.

Note that it is required to provide `start` and `end` params to specify the time interval for which to retrieve values. These values should be strings in RFC3339 format. This range is greedy, in that it will match any timeseries point included in its range, including on the boundaries.



## OpenAPI

````yaml https://api.sandbox.trlyr.com/docs/doc.json get /organisations/{organisationID}/virtual-assets/{virtualAssetID}/state-of-energy/projected
openapi: 3.1.0
info:
  description: >
    This API allows clients to manage virtual-assets and blocks on the terralayr
    system.


    A virtual asset is a virtual battery, it has static parameters that dictate
    how much power it can import / export, how much energy it can store, and how
    efficiently it charges / discharges. It also has a state of charge which
    changes as the virtual asset exports and imports power.


    A block represents a slice of the power capacity of a virtual asset over
    time, and has a schedule which can be updated to control what the
    virtual-asset will do.


    Virtual assets should be kept balanced: you should manage the schedule such
    that the such that state of charge at the end of its lifetime is 50%. It is
    possible to submit schedules that do not end at 50%, but the response will
    include information about how much imbalance is left.


    ### Authorization


    All the underneath requests require a Bearer-type `Authorization` Header
    i.e. in the form : `Authorization: Bearer <YOUR_TOKEN>`.


    To retrieve a valid token you must log in to our system using a
    password-username authentication as follows:


    ```

    POST https://api.sandbox.trlyr.com/auth/public/authenticate

    ```


    with the following JSON body:


    ```

    {
        "username": "YOUR_USERNAME",
        "password": "YOUR_PASSWORD"
    }

    ```


    Your username and password are the ones you created after receiving an
    invitation to join your organisation.


    You should receive a JSON response body from which you can extract your
    token under `access_token`.


    If you have any questions, don't hesitate to contact our account manager at
    the following address: support@trlyr.com.
  title: terralayr API
  version: 1.11.3
servers:
  - description: Production API
    url: https://api.trlyr.com
  - description: Sandbox API
    url: https://api.sandbox.trlyr.com
security: []
tags:
  - name: virtual-assets
  - name: afrr
  - name: fcr
  - name: ancillary
  - name: blocks
externalDocs:
  description: ''
  url: ''
paths:
  /organisations/{organisationID}/virtual-assets/{virtualAssetID}/state-of-energy/projected:
    get:
      tags:
        - virtual-assets
      summary: Get the projected state of energy of a virtual asset.
      description: >-
        DEPRECATED: This endpoint is deprecated and will be removed in a future
        version. To retrieve state of energy values, use the operational
        endpoint `GET
        /organisations/{organisationID}/virtual-assets/{virtualAssetID}/operational`.


        Get the projected state of energy of a virtual asset, along with
        operational limits on that state of energy.


        Returns a timeseries of the projected state of energy of a virtual asset
        as JSON. The points of the timeseries represent the state of energy of
        the virtual asset at the instant of the timestamp.


        The boundaries represent operational limits within which the state of
        energy should be kept. If the projected `soe` moves outside these bounds
        then you should aim to change the schedule such that it returns to these
        limits.


        Note that it is required to provide `start` and `end` params to specify
        the time interval for which to retrieve values. These values should be
        strings in RFC3339 format. This range is greedy, in that it will match
        any timeseries point included in its range, including on the boundaries.
      parameters:
        - description: Access token
          in: header
          name: Authorization
          required: true
          schema:
            default: Bearer <access token value>
            type: string
        - description: Organisation ID
          in: path
          name: organisationID
          required: true
          schema:
            type: string
        - description: Virtual Asset ID
          in: path
          name: virtualAssetID
          required: true
          schema:
            type: string
        - description: Query start time
          in: query
          name: start
          required: true
          schema:
            type: string
        - description: Query end time
          in: query
          name: end
          required: true
          schema:
            type: string
      requestBody:
        content:
          application/json:
            schema:
              type: object
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/StateOfEnergyProjection'
          description: OK
        '400':
          description: Bad Request
        '401':
          description: Unauthorized
        '500':
          description: Internal Server Error
      deprecated: true
components:
  schemas:
    StateOfEnergyProjection:
      properties:
        stateOfEnergyTimeseries:
          items:
            $ref: '#/components/schemas/StateOfEnergyPoint'
          type: array
          uniqueItems: false
      required:
        - stateOfEnergyTimeseries
      type: object
    StateOfEnergyPoint:
      properties:
        boundaries:
          $ref: '#/components/schemas/StateOfEnergyBoundaries'
        soe:
          example: 500
          type: number
        time:
          example: '2023-11-11T14:30:00Z'
          format: dateTime
          type: string
      required:
        - boundaries
        - soe
        - time
      type: object
    StateOfEnergyBoundaries:
      properties:
        lower:
          example: 0
          type: number
        upper:
          example: 1000
          type: number
      required:
        - lower
        - upper
      type: object

````